package puppet;


import it.cnr.isti.setest0.mappedQC.MappedQCDocument;
import it.cnr.isti.setest0.puppetSLO.PuppetSLODocument;
import it.cnr.isti.setest0.puppetScope.PuppetScopeDocument;

import java.util.HashSet;
import java.util.Vector;
import java.io.File;

import org.antlr.stringtemplate.StringTemplate;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.GuaranteeTermType;

public class GuaranteeTermActivator 
{
	private HashSet<String> servicesList;
    
    public GuaranteeTermActivator(){
        servicesList = new HashSet<String>();
    }
	
    public void ParseGuaranteeTerm(GuaranteeTermType GTT,String WSDD_File,String Destination,WSAManipulator WSA_obj,ServiceLevelObjectiveManipulator SLO_obj,String QCFile)
	{
		
		System.out.println("GuaranteeTermActivator: ParseGuaranteeTerm");
		String[] ListaServizi = null;
		ServiceScopeManipulator Scope_obj = new ServiceScopeManipulator();
		Vector ListaServiziMappati = null;
		String TipoObligated = "";  //indica se � ServiceProvider o ServiceConsumer
		ServiceObj Servizio = null;
		Support Obj_support = new Support();
		String Java = ""; //contiene il codice java da modificare
	//	String Mapped_MQC = "";
		String MQC="";
		String SLO="";
		MappedQCDocument mappedQCDoc = null;
		PuppetSLODocument SLODoc = null;
		String Lista_static = "";
		String Lista_import = "";
		String WL_function="";
		StringTemplate QCStrTempl = null;		
		StringTemplate Java_templ=null;
		File QCMappedFile = null;
		
        servicesList.clear();
        
//		Ottengo la lista dei servizi
		ListaServizi = Scope_obj.getListServiceScope(GTT);
		/*for(int k=0;k<ListaServizi.length;k++)
		{
			System.out.println("lol"+ListaServizi[k]);
		}*/
		//Per ogni servizio ricavo il file *impl.java in cui � mappato
		ListaServiziMappati = WSDD_Parser.Parse_WSDD(WSDD_File,ListaServizi);
		//System.out.println("ListaServ"+ListaServiziMappati.size());
		try
		{
			TipoObligated = GTT.getObligated().toString();
		}
		catch(Exception e){System.out.println(e);}
		//per ogni servizio mappato...
		//------------------------
		for(int conta=0;conta<ListaServiziMappati.size();conta++)
		{
			
			Servizio = (ServiceObj)ListaServiziMappati.elementAt(conta);
			//System.out.println("GuaranteeTermActivator Servizio "+Servizio.getNameService());
			//-----------------------------------------------------------------------------------
			String[] ListaMetodi = Scope_obj.getMethods(Servizio.getNameService(),GTT);
			
			Java = Obj_support.GetJavaSource(Destination+Servizio.getMappedService());
			PuppetScopeDocument.PuppetScope ScopeDoc = Scope_obj.GetPuppetScope(Servizio.getNameService(), GTT);
			            
			if(ListaMetodi.length==0)
			//in questo caso vuol dire che c'� il ServiceScope del WorkLoad
			{
				
				Java = Obj_support.PrepareWorkLoadJavaSource(Java);
				if(GTT.getQualifyingCondition()!=null)
				{		
					MQC = WSA_obj.getQualifyingCondition(GTT);
				}
				else
				{
					MQC="";
				}
				//Salvo la lista di tutti gli import da inserire nel file sorgente	
				//Leggo i tag del Service Level Objective e restituisco il codice da inserire al'interno del sorgente java
				SLODoc = SLO_obj.getServiceLevelObjective(GTT);

				if(SLODoc.getPuppetSLO().getWorkLoad()!=null)
				{
					
					Lista_static = SLO_obj.getSLOStatic("WorkLoad");
					Lista_import = SLO_obj.getSLOImport("WorkLoad");
					
					WL_function = SLO_obj.getWorkLoad_Function(SLODoc.getPuppetSLO(),TipoObligated,ScopeDoc);
			
				}

                try
				{
					QCMappedFile=new File(QCFile);
					mappedQCDoc = MappedQCDocument.Factory.parse(QCMappedFile);
					if(GTT.getQualifyingCondition()!=null)
					{
						QCStrTempl = new StringTemplate(mappedQCDoc.getMappedQC().getInit());
					}
					else
					{
						QCStrTempl = new StringTemplate("$code$");
					}
					QCStrTempl.setAttribute("Expr", MQC);
					//QCStrTempl.setAttribute("code", SLO);
					Java_templ=new StringTemplate(Java);
					Java_templ.setAttribute("WL_Function", WL_function);
					Java_templ.setAttribute("static", Lista_static);
					Java_templ.setAttribute("import", Lista_import);
					Java_templ.setAttribute("code", QCStrTempl.toString());
					
					//una volta mappato tutto lo salvo all'interno del file java corrispondente
					Obj_support.PutJavaSource(Destination+Servizio.getMappedService(),Java_templ.toString());
				}
				catch(Exception e)
				{
					System.out.println("Parse_Wsa: wsa_parser "+e);
				}
			}
			else
			{
				for(int k=0;k<ListaMetodi.length;k++)
				{	
					Java = Obj_support.PrepareJavaSource(Java,ListaMetodi[k]);

					if(GTT.getQualifyingCondition()!=null)
					{		
						MQC = WSA_obj.getQualifyingCondition(GTT);
					}
					else
					{
						MQC="";
					}
					//Salvo la lista di tutti gli import da inserire nel file sorgente
					//Leggo i tag del Service Level Objective e restituisco il codice da inserire al'interno del sorgente java
					SLODoc = SLO_obj.getServiceLevelObjective(GTT);
					SLO = SLO_obj.MapServiceLevelObjective(SLODoc.getPuppetSLO(),TipoObligated,ScopeDoc);
					if(SLODoc.getPuppetSLO().getReliability()!=null)
					{
				
						Lista_static = Lista_static+SLO_obj.getSLOStatic("Reliability");
						Lista_import = Lista_import+SLO_obj.getSLOImport("Reliability");
// Removed by Gulyx fixing the reliability						
//						Java = Obj_support.PrepareReliabilityJavaSource(Java,ListaMetodi[k]);
					}
					if(SLODoc.getPuppetSLO().getLatency()!=null)
					{
						Lista_import = Lista_import+SLO_obj.getSLOImport("Latency");
					}
					if(SLODoc.getPuppetSLO().getWorkLoad()!=null)
					{
						
						Lista_static = Lista_static+SLO_obj.getSLOStatic("WorkLoad");
						Lista_import = Lista_import+SLO_obj.getSLOImport("WorkLoad");
						
						WL_function = SLO_obj.getWorkLoad_Function(SLODoc.getPuppetSLO(),TipoObligated,ScopeDoc);
				
					}
					try
					{
						QCMappedFile=new File(QCFile);
						mappedQCDoc = MappedQCDocument.Factory.parse(QCMappedFile);
						if(GTT.getQualifyingCondition()!=null)
						{
							QCStrTempl = new StringTemplate(mappedQCDoc.getMappedQC().getInit());
						}
						else
						{
							QCStrTempl = new StringTemplate("$code$");
						}
						QCStrTempl.setAttribute("Expr", MQC);
// SLO = "qualcosa" + SLO
                        QCStrTempl.setAttribute("code", SLO);
						Java_templ=new StringTemplate(Java);
						Java_templ.setAttribute("static", Lista_static);
						Java_templ.setAttribute("import", Lista_import);                        
                        Java_templ.setAttribute("code", QCStrTempl.toString());

                        Obj_support.PutJavaSource(Destination+Servizio.getMappedService(),Java_templ.toString());
                        servicesList.add(Destination+Servizio.getMappedService());
					}
					catch(Exception e)
					{
						System.out.println("Parse_Wsa: wsa_parser "+e);
					}
				}
			}
		}
	}

    /*
     * Invoked after the ParseGuaranteeTerm returns the list of file name of those services 
     * that will exported server side. it does not include services that only exports methods 
     * for the workload generations.
     */
    public HashSet<String> getServerSideServicesList() {
        return servicesList;
    }
}
