package puppet.ambition;

import java.io.File;

import puppet.Support;

public class Fuppet {

    private String serviceLocation;

    private String serviceWSDLPath;
    
    private String serviceClassName;
    
    private Support puppetFacilities;
    
    private String content;
    
    public Fuppet(String serviceLocation, String serviceWSDLPath) {
      this.serviceLocation = serviceLocation;
      this.puppetFacilities = new Support(); 
      this.serviceWSDLPath = serviceWSDLPath;
      this.content = puppetFacilities.GetJavaSource(serviceLocation);
      
// This variable is it used just to extract the serviceClassName
      File dummyFile = new File(serviceLocation);
      String tempBuffer = dummyFile.getName();
// The extrension string ".java" has 5 characters    
      this.serviceClassName = tempBuffer.substring(0, tempBuffer.length()-5);
    }

    
/*
 * Acctually adds the Autidion Statements
 */    
    public String parse (){
        ClassCodeProcessor ambitionProcessor = new ClassCodeProcessor(this.serviceClassName,this.serviceWSDLPath);
        System.out.println("+++++++++++++++++++++++++");
        String sourceCodeWithAmbition = ambitionProcessor.parseClass(content);
        return sourceCodeWithAmbition;
      }

/*
* Acctually adds the Autidion Statements and dump it on the file systems
*/    
    public void parseAndDump (){
        ClassCodeProcessor ambitionProcessor = new ClassCodeProcessor(this.serviceClassName,this.serviceWSDLPath);
        System.out.println("+++++++++++++++++++++++++");
        String sourceCodeWithAmbition = ambitionProcessor.parseClass(content);
        puppetFacilities.PutJavaSource(serviceLocation,sourceCodeWithAmbition);                
      }
        
    public String getServiceLocation() {
        return serviceLocation;
    }
    
    
        
}
