/* Generated By:JJTree: Do not edit this line. ASTEnumerationConstNode.java */

/* Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 */

package info.frantzen.testing.ssmsimulator.interpreter.javacc;

import java.util.HashSet;
import java.util.Iterator;
import info.frantzen.testing.ssmsimulator.types.Enumeration;
import info.frantzen.testing.ssmsimulator.types.EnumerationInstance;
import info.frantzen.testing.ssmsimulator.types.Type;

public class ASTEnumerationConstNode extends SimpleNode {
    
    String val;
    
    public ASTEnumerationConstNode(int id) {
        super(id);
    }
    
    public ASTEnumerationConstNode(DumontParser p, int id) {
        super(p, id);
    }
    
    public void interpret() {
        String enumValueName = val.substring(0,val.indexOf('@'));
        String enumTypeName = val.substring(val.indexOf('@')+1, val.length());
        
        EnumerationInstance ei = null;
        
        // Find the Enumeration type
        HashSet<Type> types = getParser().getSSM().getTypes();
        
        for (Iterator it = types.iterator(); it.hasNext() ;) {
            Type t = (Type) it.next();
            if (t instanceof Enumeration) {
                // TODO also here we need an .equals ...
                if (t.getName().equals(enumTypeName)) {
//                    String[] sa = ((Enumeration) t).getNames();
//                    boolean found = false;
//                    for (int i = 0; i < sa.length; i++) {
//                        if (sa[i].equals(enumValueName))
//                            found = true;
//                    }
//                    if (!found) {
//                        System.out.println("ASTEnumerationConstNode: WARNING: The enumertion value " + enumValueName + " does not exist!");
//                        System.exit(1);
//                    }
                    ei = new EnumerationInstance((Enumeration) t, enumValueName);
                }
            }
        }
        
//        if (ei == null) {
//            // TODO
//            System.out.println("ASTEnumerationConstNode: WARNING: The enumertion type " + enumTypeName + " does not exist!");
//            System.exit(1);
//        }
        
        // Put the instance on the Stack
        stack[++top] = ei;
    }
    
    public int typeCheck() throws DumontParser.IllegalTypeException {
        String enumValueName = val.substring(0,val.indexOf('@'));
        String enumTypeName = val.substring(val.indexOf('@')+1, val.length());
        
        // Find the Enumeration type
        HashSet<Type> types = getParser().getSSM().getTypes();
        
        boolean enumTypeFound = false;
        for (Iterator it = types.iterator(); it.hasNext() ;) {
            Type t = (Type) it.next();
            if (t instanceof Enumeration) {
                // TODO also here we need an .equals ...
                if (t.getName().equals(enumTypeName)) {
                    String[] sa = ((Enumeration) t).getNames();
                    boolean enumValueFound = false;
                    for (int i = 0; i < sa.length; i++) {
                        if (sa[i].equals(enumValueName))
                            enumValueFound = true;
                    }
                    if (!enumValueFound) {
                        throw new DumontParser.IllegalTypeException("The enumeration value " + enumValueName + " does not exist for the enumeration " + enumTypeName + ".");
                    }
                    enumTypeFound = true;
                }
            }
        }
        
        if (!enumTypeFound) {
            throw new DumontParser.IllegalTypeException("The enumeration type " + enumTypeName + " does not exist.");
        }
        
        return type;
    }
    
    public String getPrologQuery() throws DumontParser.RuntimeViolation {
        String enumValueName = val.substring(0,val.indexOf('@'));
        String enumTypeName = val.substring(val.indexOf('@')+1, val.length());
        
        Enumeration enu = null;
        EnumerationInstance ei = null;
        
        // Find the Enumeration type
        HashSet<Type> types = getParser().getSSM().getTypes();
        
        for (Iterator it = types.iterator(); it.hasNext() ;) {
            Type t = (Type) it.next();
            if (t instanceof Enumeration) {
                // TODO also here we need an .equals ...
                if (t.getName().equals(enumTypeName)) {
                    enu = (Enumeration) t;
                    ei = new EnumerationInstance((Enumeration) t, enumValueName);
                }
            }
        }
        
        return "node_s(" + Integer.toString(enu.instanceAsNumber(ei)) + ",empty)";
    }
    
    
}
