/* Generated By:JJTree: Do not edit this line. ASTId.java */

/* Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 */

package info.frantzen.testing.ssmsimulator.interpreter.javacc;

import info.frantzen.testing.ssmsimulator.interpreter.javacc.DumontParser.RuntimeViolation;
import info.frantzen.testing.ssmsimulator.ssm.InteractionVariable;
import info.frantzen.testing.ssmsimulator.ssm.LocationVariable;
import info.frantzen.testing.ssmsimulator.ssm.Message;
import info.frantzen.testing.ssmsimulator.types.ST_PosInt;
import info.frantzen.testing.ssmsimulator.types.ST_PosIntInstance;
import info.frantzen.testing.ssmsimulator.types.ST_PseudoPosDouble;
import info.frantzen.testing.ssmsimulator.types.ST_PseudoPosDoubleInstance;
import info.frantzen.testing.ssmsimulator.types.ST_String;
import info.frantzen.testing.ssmsimulator.types.ST_StringInstance;
import info.frantzen.testing.ssmsimulator.types.TypedList;
import info.frantzen.testing.ssmsimulator.types.TypedListInstance;
import java.util.ArrayList;
import info.frantzen.testing.ssmsimulator.ssm.Variable;
import info.frantzen.testing.ssmsimulator.types.ComplexType;
import info.frantzen.testing.ssmsimulator.types.ComplexTypeInstance;
import info.frantzen.testing.ssmsimulator.types.Enumeration;
import info.frantzen.testing.ssmsimulator.types.EnumerationInstance;
import info.frantzen.testing.ssmsimulator.types.SimpleType;
import info.frantzen.testing.ssmsimulator.types.Type;
import info.frantzen.testing.ssmsimulator.types.TypeInstance;
import java.util.HashSet;
import java.util.Iterator;

public class ASTId extends SimpleNode {
    public ASTId(int id) {
        super(id);
    }
    
    public ASTId(DumontParser p, int id) {
        super(p, id);
    }
    
    ArrayList<String> names = new ArrayList<String>();
    
    public void interpret() throws RuntimeViolation {
        
        System.out.println("ASTId.java interpret(): " + names);
        
        int nameIndex = 0;
        
        String varName = names.get(nameIndex++);
        Variable var = null;
        var = findVariable(varName);
        
        
//        Object o = getParser().getSymTab().get(names.get(nameIndex++));
//        Variable var = (Variable) o;
        
        Type type = var.getType();
        TypeInstance instance = var.getInstance();
        
        if (instance == null)
            throw new DumontParser.RuntimeViolation("Found a null instance for type " + type.getName() + " here: " + flatten(names));
        
        int fieldIndex = -1;
        
        // we have a complex type, a complex type instance, and a name: names.get(nameIndex)
        while ((type instanceof ComplexType) && (nameIndex < names.size())) {
            // System.out.println("Checking: " + type.getName() + " " + instance.toString());
            
            // The fields are name / Type pairs
            Object[][] fields = ((ComplexType) type).getFields();
            for (int i=0; i<fields.length; i++) {
                // TODO: also here == does not work, .equals is needed...
                if ( ((String) fields[i][0]).equals(names.get(nameIndex)) ) {
                    fieldIndex = i;
                    type = (Type) fields[i][1];
                    break; }
            }
            nameIndex++;
            // The fields are TypeInstances of the corresponding Types
            
            Object[] fieldvalues = (Object[]) ((ComplexTypeInstance) instance).getValue();
            
            if (fieldvalues[fieldIndex] == null)
                throw new DumontParser.RuntimeViolation("Found a null instance for type " + type.getName() + " here: " + flatten(names));
            
            instance = (TypeInstance) fieldvalues[fieldIndex];
        }
        
        if (type instanceof ComplexType) {
            stack[++top] = instance;
        }
        
        if (type instanceof Enumeration) {
            stack[++top] = instance;
        }
        
        if (type instanceof SimpleType) {
            String restriction = ((SimpleType) type).getRestriction();
            if (restriction == "Boolean") {
                stack[++top] = new Boolean((Boolean) instance.getValue());
            } else if (restriction == "Integer") {
                stack[++top] = new Integer((Integer) instance.getValue());
            } else if (restriction == "Double") {
                stack[++top] = new Double((Double) instance.getValue());
            } else if (restriction == "String") {
                stack[++top] = new String((String) instance.getValue());
            } else { // TODO throw unsupported restriction exception
            }
        }
    }
    
    
    public int typeCheck() throws DumontParser.IllegalTypeException {
        
        System.out.println("ASTId.java typeCheck(): " + names);
        
        int nameIndex = 0;
        
        String varName = names.get(nameIndex++);
        Variable var = null;
        var = findVariable(varName);
        
        
        //     Object o = getParser().getSymTab().get(names.get(nameIndex++));
        if (var == null) {
            throw new DumontParser.IllegalTypeException("Undefined variable found: "+ names.get(0)  + " here: " + flatten(names));
        }
        // Variable var = (Variable) o;
        
        Type type = var.getType();
        
        int fieldIndex = -1;
        
        // we have a complex type, a complex type instance, and a name: names.get(nameIndex)
        while (((type instanceof ComplexType) || (type instanceof TypedList)) && (nameIndex < names.size())) {
            
            if (type instanceof ComplexType) {
                // The fields are name / Type pairs
                Object[][] fields = ((ComplexType) type).getFields();
                boolean foundField = false;
                for (int i=0; i<fields.length; i++) {
                    // TODO: also here == does not work, .equals is needed...
                    if ( ((String) fields[i][0]).equals(names.get(nameIndex)) ) {
                        foundField = true;
                        fieldIndex = i;
                        type = (Type) fields[i][1];
                        break; }
                }
                
                if (!foundField)
                    throw new DumontParser.IllegalTypeException("The complex type variable " + names.get(nameIndex-1) + " has no" +
                            " field " + names.get(nameIndex) + ".");
                
            }
            
            if (type instanceof TypedList) {
                //nameIndex++;
                String listOperation = names.get(nameIndex);
                if (listOperation.equals("head()")) {
                    type = ((TypedList) type).getType();
                } else if (listOperation.equals("tail()")) {
                    // type stays the same
                } else if (listOperation.equals("size()")){
                    type = new ST_PosInt();
                } else
                    throw new DumontParser.IllegalTypeException("Illegal operation for list " + names.get(nameIndex-1) + ": " +
                            names.get(nameIndex) + ".");
            }
            nameIndex++;
        }
        
        if (type instanceof ComplexType)
            this.type = DumontParserConstants.COMPLEX;
        else if (type instanceof TypedList)
            this.type = DumontParserConstants.LIST;
        else if (type instanceof Enumeration)
            this.type = DumontParserConstants.ENUM;
        else // (type instanceof SimpleType)
        {
            SimpleType stype = (SimpleType) type;
            String restriction = stype.getRestriction();
            if (restriction == "Boolean") {
                this.type = DumontParserConstants.BOOL;
            } else if (restriction == "Integer") {
                this.type = DumontParserConstants.INT;
            } else if (restriction == "Double") {
                this.type = DumontParserConstants.FLOAT;
            } else if (restriction == "String") {
                this.type = DumontParserConstants.STRING;
            } else {
                throw new DumontParser.IllegalTypeException("Found unknown restriction " + restriction + " here: " + flatten(names));
            }
        }
        
        return this.type;
    }
    
    public String getPrologQuery() throws RuntimeViolation {
        
        System.out.println("ASTId.java getPrologQuery(): " + names);
        
        int nameIndex = 0;
        
        String varName = names.get(nameIndex++);
        Variable var = null;
        var = findVariable(varName);
        
        
        //       Object o = getParser().getSymTab().get(names.get(nameIndex++));
        //       Variable var = (Variable) o;
        
        Type type = var.getType();
        TypeInstance instance = var.getInstance();
        
        if (var instanceof LocationVariable && instance == null)
            throw new DumontParser.RuntimeViolation("Found a null instance for type " + type.getName() + " here: " + flatten(names));
        
        int fieldIndex = -1;
        
        // we have a complex type, a complex type instance, and a name: names.get(nameIndex)
        while (((type instanceof ComplexType) || (type instanceof TypedList)) && (nameIndex < names.size())) {
            // System.out.println("Checking: " + type.getName());
            
            if (type instanceof ComplexType) {
                
                // The fields are name / Type pairs
                Object[][] fields = ((ComplexType) type).getFields();
                for (int i=0; i<fields.length; i++) {
                    // TODO: also here == does not work, .equals is needed...
                    if ( ((String) fields[i][0]).equals(names.get(nameIndex)) ) {
                        fieldIndex = i;
                        type = (Type) fields[i][1];
                        break; }
                }
                
                if (var instanceof LocationVariable) {
                    Object[] fieldvalues = (Object[]) ((ComplexTypeInstance) instance).getValue();
                    if (fieldvalues[fieldIndex] == null)
                        throw new DumontParser.RuntimeViolation("Found a null instance for type " + type.getName() + " here: " + flatten(names));
                    instance = (TypeInstance) fieldvalues[fieldIndex];
                }
            }
            
            if (type instanceof TypedList) {
                String listOperation = names.get(nameIndex);
                if (listOperation.equals("head()")) {
                    type = ((TypedList) type).getType();
                    
                    if (var instanceof LocationVariable)
                        instance = ((TypedListInstance) instance).getHead();
                    
                } else if (listOperation.equals("tail()")) {
                    // type stays the same
                    
                    if (var instanceof LocationVariable)
                        instance = ((TypedListInstance) instance).getTail();
                    
                    
                } else if (listOperation.equals("size()")){
                    type = new ST_PosInt();
                    
                    if (var instanceof LocationVariable)
                        instance = new ST_PosIntInstance(((TypedListInstance) instance).getSize());
                    
                } else
                    throw new DumontParser.RuntimeViolation("Illegal operation for list " + names.get(nameIndex-1) + ": " +
                            names.get(nameIndex) + ".");
            }
            nameIndex++;
        }
        
        
        
        
        if (type instanceof ComplexType) {
            throw new DumontParser.RuntimeViolation("Complex types not supported by the solver: " + type.getName() + " here: " + flatten(names));
        }
        
        if (type instanceof TypedList) {
            throw new DumontParser.RuntimeViolation("Typed lists are not supported by the solver: " + type.getName() + " here: " + flatten(names));
        }
        
        if (type instanceof Enumeration) {
            if (var instanceof LocationVariable)
                return "node_s(" + Integer.toString(((Enumeration) type).instanceAsNumber((EnumerationInstance) instance)) + ",empty)";
            if (var instanceof InteractionVariable)
                return makeConstrainedPrologVariableLeaf(flatten(names), 0, ((Enumeration) type).getNames().length-1);
        }
        
        if (type instanceof SimpleType) {
            String restriction = ((SimpleType) type).getRestriction();
            if (restriction == "Boolean") {
                
                if (var instanceof LocationVariable) {
                    Boolean b = new Boolean((Boolean) instance.getValue());
                    if (b)
                        return "node_s(" + '1' + ",empty)";
                    else
                        return "node_s(" + '0' + ",empty)";
                }
                if (var instanceof InteractionVariable) {
                    return makeConstrainedPrologVariableLeaf(flatten(names), 0, 1);
                }
                
            } else if (restriction == "Integer") {
                // better: check for type instanceof ST_PosInt here
                if (var instanceof LocationVariable) {
                    Integer i = new Integer((Integer) instance.getValue());
                    if (i >= 0)
                        return "node_s(" + i.toString() + ",empty)";
                    else
                        throw new DumontParser.RuntimeViolation("Negative Integers are not supported by the solver: " + type.getName() + " here: " + flatten(names));
                }
                if (var instanceof InteractionVariable)
                    return makePrologVariableLeaf(flatten(names));
                
            } else if (restriction == "Double") {
                if (type instanceof ST_PseudoPosDouble) {
                    if (var instanceof LocationVariable) {
                        return "node_s(" + Integer.toString(((ST_PseudoPosDoubleInstance) instance).asFlatInteger()) + ",empty)";
                    }
                    if (var instanceof InteractionVariable)
                        return makePrologVariableLeaf(flatten(names));
                } else
                    throw new DumontParser.RuntimeViolation("Double type not supported by the solver: " + type.getName() + " here: " + flatten(names) + " , use pseudo doubles.");
                
            } else if (restriction == "String") {
                if (var instanceof LocationVariable)
                    return "node_s(" + Integer.toString(ST_String.instanceAsNumber((ST_StringInstance) instance)) + ",empty)";
                if (var instanceof InteractionVariable)
                    return makePrologVariableLeaf(flatten(names));
            } else { // TODO throw unsupported restriction exception
            }
        }
        
        return null;
    }
    
    private String flatten(ArrayList<String> names) {
        StringBuffer sb = new StringBuffer();
        
        for(Iterator it = names.iterator(); it.hasNext() ;)
            sb.append(((String) it.next()) + '.');
        
        // delete the last dot...
        sb.deleteCharAt(sb.length()-1);
        
        return sb.toString();
    }
    
    private String makePrologVariableLeaf(String varname) {
        if (! prologVartab.containsKey(varname)) {
            String pName = getNextPrologVarName();
            prologVartab.put(varname, pName);
            return "node_s(" + pName + ",empty)";
        } else {
            return "node_s(" + (String) prologVartab.get(varname) + ",empty)";
        }
    }
    
    private String makeConstrainedPrologVariableLeaf(String varname, int lowerBound, int upperBound) {
        if (! prologVartab.containsKey(varname)) {
            String pName = getNextPrologVarName();
            prologVartab.put(varname, pName);
            return "node_c(" + pName + ',' + Integer.toString(lowerBound) + ',' + Integer.toString(upperBound) + ",empty)";
        } else { // to simplify the constraint we don't repeat the node_c here, the var is already constrained since it is in the prologVartab
            return "node_s(" + (String) prologVartab.get(varname) + ",empty)";
        }
    }
    
    private Variable findVariable(final String varName) {
        
        System.out.println("XXXXXXXX Call with " + varName);
        
        ArrayList<Variable> vars = new ArrayList(getParser().getVariables());

        System.out.println("XXXXXXXX Variable are " + vars);
        
        
        for (Iterator it = vars.iterator(); it.hasNext(); ) {
            Variable v = (Variable) it.next();
            
            System.out.println("XXXXXXXX Compare with " + v.getName());
            
            
            if (v.getName().equals(varName)) {
                
                System.out.println("XXXXXXXX (name ok)");
                
                
                if (v instanceof LocationVariable) {
                    System.out.println("XXXXXXXX (location var, done)");
                    
                    return v;
                    
                }
                if (v instanceof InteractionVariable) {

                    System.out.println("XXXXXXXX (interaction var)");
                    System.out.println("XXXXXXXX " + getParser().getSwitch().getMessage().getType());
                    
// v.getType()
                    if (getParser().getSwitch().getMessage().getType().contains(v)) {
                        
                        System.out.println("XXXXXXXX (var is in type, done)");
                        return v;
                        
                    }
                    
                }
            }
        }
//
//        ArrayList<InteractionVariable> mtype = getParser().getSwitch().getMessage().getType();
//
//        System.out.println(getParser().getSwitch());
//        if (mtype == null)
//            System.out.println("XXXXXXXXXXXXXXXXXXXXXXXX");
//
//        for (Iterator it = mtype.iterator(); it.hasNext(); ) {
//            InteractionVariable v = (InteractionVariable) it.next();
//            if (v.getName().equals(varName))
//                var = v;
//        }
        return null;
    }
    
}
