/*
 * SimpleTypeInstance.java
 * Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 *
 * Created on January 8, 2007, 6:28 PM
 *
 */

package info.frantzen.testing.ssmsimulator.types;

/**
 * A simple type instance represents an instance of an {@link SimpleType simple type}, i.e.
 * an instance of a Java primitive type.
 * This class is abstract and just serves to type the objects.
 * @author Lars Frantzen
 * @version 0.1
 */
public abstract class SimpleTypeInstance extends TypeInstance {
    
    /**
     * Creates a new instance of SimpleTypeInstance.
     * @param o the value of the simple type instance (will always be a (wrapped) primitive java
     * type object, e.g. a Double or a Boolean)
     */
    public SimpleTypeInstance(Object o) {
        super(o);
    }    
}
